3 # Copyright (c) 2005 Junio C Hamano.
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
15 v,verbose! display a diffstat of what changed upstream
16 q,quiet! be quiet. implies --no-stat
17 autostash automatically stash/stash pop before and after
18 fork-point use 'merge-base --fork-point' to refine upstream
19 onto=! rebase onto given branch instead of upstream
20 r,rebase-merges? try to rebase merges instead of skipping them
21 p,preserve-merges! try to recreate merges instead of ignoring them
22 s,strategy=! use the given merge strategy
23 X,strategy-option=! pass the argument through to the merge strategy
24 no-ff! cherry-pick all commits, even if unchanged
25 f,force-rebase! cherry-pick all commits, even if unchanged
26 m,merge! use merging strategies to rebase
27 i,interactive! let the user edit the list of commits to rebase
28 x,exec=! add exec lines after each commit of the editable list
29 k,keep-empty preserve empty commits during rebase
30 allow-empty-message allow rebasing commits with empty messages
31 stat! display a diffstat of what changed upstream
32 n,no-stat! do not show diffstat of what changed upstream
33 verify allow pre-rebase hook to run
34 rerere-autoupdate allow rerere to update index with resolved conflicts
35 root! rebase all reachable commits up to the root(s)
36 autosquash move commits that begin with squash!/fixup! under -i
37 signoff add a Signed-off-by: line to each commit
38 committer-date-is-author-date! passed to 'git am'
39 ignore-date! passed to 'git am'
40 whitespace=! passed to 'git apply'
41 ignore-whitespace! passed to 'git apply'
42 C=! passed to 'git apply'
43 S,gpg-sign? GPG-sign commits
46 abort! abort and check out the original branch
47 skip! skip current patch and continue
48 edit-todo! edit the todo list during an interactive rebase
49 quit! abort but keep HEAD where it is
50 show-current-patch! show the patch file being applied or merged
53 set_reflog_action rebase
54 require_work_tree_exists
59 ok_to_skip_pre_rebase=
63 unset restrict_revision
68 merge_dir="$GIT_DIR"/rebase-merge
69 apply_dir="$GIT_DIR"/rebase-apply
72 test "$(git config --bool rebase.stat)" = true && diffstat=t
73 autostash="$(git config --bool rebase.autostash || echo false)"
79 allow_rerere_autoupdate=
80 # Non-empty if a rebase was in progress when 'git rebase' was invoked
82 # One of {am, merge, interactive}
84 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
86 # One of {'', continue, skip, abort}, as parsed from command line
93 allow_empty_message=--allow-empty-message
95 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
96 case "$(git config --bool commit.gpgsign)" in
97 true) gpg_sign_opt=-S ;;
102 read_basic_state () {
103 test -f "$state_dir/head-name" &&
104 test -f "$state_dir/onto" &&
105 head_name=$(cat "$state_dir"/head-name) &&
106 onto=$(cat "$state_dir"/onto) &&
107 # We always write to orig-head, but interactive rebase used to write to
108 # head. Fall back to reading from head to cover for the case that the
109 # user upgraded git with an ongoing interactive rebase.
110 if test -f "$state_dir"/orig-head
112 orig_head=$(cat "$state_dir"/orig-head)
114 orig_head=$(cat "$state_dir"/head)
116 GIT_QUIET=$(cat "$state_dir"/quiet) &&
117 test -f "$state_dir"/verbose && verbose=t
118 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
119 test -f "$state_dir"/strategy_opts &&
120 strategy_opts="$(cat "$state_dir"/strategy_opts)"
121 test -f "$state_dir"/allow_rerere_autoupdate &&
122 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
123 test -f "$state_dir"/gpg_sign_opt &&
124 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
125 test -f "$state_dir"/signoff && {
126 signoff="$(cat "$state_dir"/signoff)"
132 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
134 { git gc --auto || true; } &&
138 run_specific_rebase () {
139 if [ "$interactive_rebase" = implied ]; then
146 if test -z "$preserve_merges"
150 git_rebase__preserve_merges
157 elif test $ret -eq 2 # special exit status for rebase -i
160 rm -rf "$state_dir" &&
166 run_pre_rebase_hook () {
167 if test -z "$ok_to_skip_pre_rebase" &&
168 test -x "$(git rev-parse --git-path hooks/pre-rebase)"
170 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
171 die "$(gettext "The pre-rebase hook refused to rebase.")"
175 test -f "$apply_dir"/applying &&
176 die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
178 if test -d "$apply_dir"
181 state_dir="$apply_dir"
182 elif test -d "$merge_dir"
184 if test -d "$merge_dir"/rewritten
187 interactive_rebase=explicit
189 elif test -f "$merge_dir"/interactive
192 interactive_rebase=explicit
196 state_dir="$merge_dir"
198 test -n "$type" && in_progress=t
205 ok_to_skip_pre_rebase=yes
208 ok_to_skip_pre_rebase=
210 --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
211 test $total_argc -eq 2 || usage
218 cmd="${cmd}exec ${1#--exec=}${LF}"
219 test -z "$interactive_rebase" && interactive_rebase=implied
222 interactive_rebase=explicit
227 --allow-empty-message)
228 allow_empty_message=--allow-empty-message
235 test -z "$interactive_rebase" && interactive_rebase=implied
240 rebase-cousins) rebase_cousins=t;;
241 no-rebase-cousins) rebase_cousins=;;
242 *) die "Unknown mode: $1";;
244 test -z "$interactive_rebase" && interactive_rebase=implied
248 test -z "$interactive_rebase" && interactive_rebase=implied
266 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}" | sed -e s/^.//)"
268 test -z "$strategy" && strategy=recursive
271 strategy="${1#--strategy=}"
293 git_am_opt="$git_am_opt -q"
298 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
299 case "${1#--whitespace=}" in
306 git_am_opt="$git_am_opt $1"
314 --committer-date-is-author-date|--ignore-date)
315 git_am_opt="$git_am_opt $1"
319 git_am_opt="$git_am_opt $1"
324 --force-rebase|--no-ff)
327 --rerere-autoupdate|--no-rerere-autoupdate)
328 allow_rerere_autoupdate="$1"
334 gpg_sign_opt="-S${1#--gpg-sign=}"
346 test $# -gt 2 && usage
350 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
351 # Only interactive rebase uses detailed reflog messages
352 if test -n "$interactive_rebase" && test "$GIT_REFLOG_ACTION" = rebase
354 GIT_REFLOG_ACTION="rebase -i ($action)"
355 export GIT_REFLOG_ACTION
359 if test "$action" = "edit-todo" && test -z "$interactive_rebase"
361 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
367 git rev-parse --verify HEAD >/dev/null ||
368 die "$(gettext "Cannot read HEAD")"
369 git update-index --ignore-submodules --refresh &&
370 git diff-files --quiet --ignore-submodules || {
371 echo "$(gettext "You must edit all merge conflicts and then
372 mark them as resolved using git add")"
379 output git reset --hard HEAD || exit $?
388 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
389 die "$(eval_gettext "Could not move back to \$head_name")"
392 output git reset --hard $orig_head
397 exec rm -rf "$state_dir"
404 die "BUG: run_specific_rebase is not supposed to return here"
408 # Make sure no rebase is in progress
409 if test -n "$in_progress"
411 state_dir_base=${state_dir##*/}
412 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
413 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
415 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
416 I wonder if you are in the middle of another rebase. If that is the
419 If that is not the case, please
420 $cmd_clear_stale_rebase
421 and run me again. I am stopping in case you still have something
425 if test -n "$rebase_root" && test -z "$onto"
427 test -z "$interactive_rebase" && interactive_rebase=implied
430 if test -n "$keep_empty"
432 test -z "$interactive_rebase" && interactive_rebase=implied
435 if test -n "$interactive_rebase"
437 if test -z "$preserve_merges"
444 state_dir="$merge_dir"
445 elif test -n "$do_merge"
448 state_dir="$merge_dir"
451 state_dir="$apply_dir"
454 if test -t 2 && test -z "$GIT_QUIET"
456 git_format_patch_opt="$git_format_patch_opt --progress"
459 if test -n "$git_am_opt"; then
460 incompatible_opts=$(echo " $git_am_opt " | \
461 sed -e 's/ -q / /g' -e 's/^ \(.*\) $/\1/')
462 if test -n "$interactive_rebase"
464 if test -n "$incompatible_opts"
466 die "$(gettext "error: cannot combine interactive options (--interactive, --exec, --rebase-merges, --preserve-merges, --keep-empty, --root + --onto) with am options ($incompatible_opts)")"
469 if test -n "$do_merge"; then
470 if test -n "$incompatible_opts"
472 die "$(gettext "error: cannot combine merge options (--merge, --strategy, --strategy-option) with am options ($incompatible_opts)")"
477 if test -n "$signoff"
479 test -n "$preserve_merges" &&
480 die "$(gettext "error: cannot combine '--signoff' with '--preserve-merges'")"
481 git_am_opt="$git_am_opt $signoff"
485 if test -n "$preserve_merges"
487 # Note: incompatibility with --signoff handled in signoff block above
488 # Note: incompatibility with --interactive is just a strong warning;
489 # git-rebase.txt caveats with "unless you know what you are doing"
490 test -n "$rebase_merges" &&
491 die "$(gettext "error: cannot combine '--preserve_merges' with '--rebase-merges'")"
494 if test -n "$rebase_merges"
496 test -n "$strategy_opts" &&
497 die "$(gettext "error: cannot combine '--rebase_merges' with '--strategy-option'")"
498 test -n "$strategy" &&
499 die "$(gettext "error: cannot combine '--rebase_merges' with '--strategy'")"
502 if test -z "$rebase_root"
506 if ! upstream_name=$(git rev-parse --symbolic-full-name \
507 --verify -q @{upstream} 2>/dev/null)
510 error_on_missing_default_upstream "rebase" "rebase" \
511 "against" "git rebase $(gettext '<branch>')"
514 test "$fork_point" = auto && fork_point=t
516 *) upstream_name="$1"
517 if test "$upstream_name" = "-"
519 upstream_name="@{-1}"
524 upstream=$(peel_committish "${upstream_name}") ||
525 die "$(eval_gettext "invalid upstream '\$upstream_name'")"
526 upstream_arg="$upstream_name"
530 empty_tree=$(git hash-object -t tree /dev/null)
531 onto=$(git commit-tree $empty_tree </dev/null)
536 test $# -gt 1 && usage
540 # Make sure the branch to rebase onto is valid.
541 onto_name=${onto-"$upstream_name"}
544 if left=${onto_name%...*} right=${onto_name#*...} &&
545 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
549 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
552 die "$(eval_gettext "\$onto_name: there is no merge base")"
556 die "$(eval_gettext "\$onto_name: there is no merge base")"
560 onto=$(peel_committish "$onto_name") ||
561 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
565 # If the branch to rebase is given, that is the branch we will rebase
566 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
567 # $orig_head -- commit object name of tip of the branch before rebasing
568 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
572 # Is it "rebase other $branchname" or "rebase other $commit"?
576 # Is it a local branch?
577 if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
578 orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
580 head_name="refs/heads/$branch_name"
581 # If not is it a valid ref (branch or commit)?
582 elif orig_head=$(git rev-parse -q --verify "$branch_name")
584 head_name="detached HEAD"
587 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
591 # Do not need to switch branches, we are already on it.
592 if branch_name=$(git symbolic-ref -q HEAD)
594 head_name=$branch_name
595 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
597 head_name="detached HEAD"
600 orig_head=$(git rev-parse --verify HEAD) || exit
603 die "BUG: unexpected number of arguments left to parse"
607 if test "$fork_point" = t
609 new_upstream=$(git merge-base --fork-point "$upstream_name" \
610 "${switch_to:-HEAD}")
611 if test -n "$new_upstream"
613 restrict_revision=$new_upstream
617 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
619 stash_sha1=$(git stash create "autostash") ||
620 die "$(gettext 'Cannot autostash')"
622 mkdir -p "$state_dir" &&
623 echo $stash_sha1 >"$state_dir/autostash" &&
624 stash_abbrev=$(git rev-parse --short $stash_sha1) &&
625 echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
629 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
631 # Now we are rebasing commits $upstream..$orig_head (or with --root,
632 # everything leading up to $orig_head) on top of $onto
634 # Check if we are already based on $onto with linear history,
635 # but this should be done only when upstream and onto are the same
636 # and if this is not an interactive rebase.
637 mb=$(git merge-base "$onto" "$orig_head")
638 if test -z "$interactive_rebase" && test "$upstream" = "$onto" &&
639 test "$mb" = "$onto" && test -z "$restrict_revision" &&
641 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
643 if test -z "$force_rebase"
645 # Lazily switch to the target branch if needed...
646 test -z "$switch_to" ||
647 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
648 git checkout -q "$switch_to" --
649 if test "$branch_name" = "HEAD" &&
650 ! git symbolic-ref -q HEAD
652 say "$(eval_gettext "HEAD is up to date.")"
654 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
659 if test "$branch_name" = "HEAD" &&
660 ! git symbolic-ref -q HEAD
662 say "$(eval_gettext "HEAD is up to date, rebase forced.")"
664 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
669 # If a hook exists, give it a chance to interrupt
670 run_pre_rebase_hook "$upstream_arg" "$@"
672 if test -n "$diffstat"
674 if test -n "$verbose"
676 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
678 # We want color (if set), but no pager
679 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
682 test -n "$interactive_rebase" && run_specific_rebase
684 # Detach HEAD and reset the tree
685 say "$(gettext "First, rewinding head to replay your work on top of it...")"
687 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
688 git checkout -q "$onto^0" || die "could not detach HEAD"
689 git update-ref ORIG_HEAD $orig_head
691 # If the $onto is a proper descendant of the tip of the branch, then
692 # we just fast-forwarded.
693 if test "$mb" = "$orig_head"
695 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
696 move_to_original_branch
701 if test -n "$rebase_root"
703 revisions="$onto..$orig_head"
705 revisions="${restrict_revision-$upstream}..$orig_head"